#ifndef SLESOLV_H
#define SLESOLV_H

#include <stdio.h>
#include "galias.h"
#include "xfile.h"
#include "precond.h"
#include "seqfeti.h"
#include "seqschur.h"
//#include "seqtop.h"
//#include "seqselnodes.h"
//#include "saddpoint.h"
class saddpoint;

//#include "gmatrix.h"
class gmatrix;
class gtopology;
//class seqfeti;
//class precond;

/**
   class slesolv defines type of solver of systems of linear algebraic equations
   
   JK
*/

class slesolv
{
 public:
  slesolv ();
  ~slesolv ();
  void read (gtopology *top,XFILE *in,long mespr);
  void print (FILE *out);
  void initiate (slesolv *ssle);

  void prepare_data (long *ndof,gtopology *top,FILE *out);
  
  void solve_system (gtopology *gt,gmatrix *gm,double *lhs,double *rhs,FILE *out);
  
  ///  type of solver of system of linear algebraic equations
  linsolvertype tlinsol;

  ///  if tlinsol is conden, additional information is needed
  linsolvertype tsol;
  
  ///  block size in direct sparse solver
  unsigned char bsize;
    
  ///  computer zero
  double zero;
  
  ///  maximum number of iterations in iterative methods
  long ni;
  ///  required norm of residual %vector
  double err;
  ///  number of performed iterations (atual number of iterations)
  long ani;
  ///  attained norm of residual %vector
  double aerr;
  
  ///  number of rows which are not condensed
  long nbdof;

  ///  preconditioner
  precond prec;
  
  ///  FETI solver
  seqfeti feti;
  
  ///  solver based on the Schur complement method
  seqschur schur;

  //  saddle point solver
  saddpoint *sp;
};

#endif
